/* $Id: ast_mainblock.h 6504 2023-04-03 17:46:07Z aron $ */
/*
    Welltype parser and AST
    Copyright (C) 2014-2023  Aron Barath

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef WTPARSER_AST_MAINBLOCK_H
#define WTPARSER_AST_MAINBLOCK_H

#include "../astnode.h"
#include "ast_block.h"
#include "welltype/wtruntime.h"

namespace wtast
{

class ExceptionCompound;

class MainBlock : public Block
{
	ExceptionCompound* mBody;
	wt_u32             mCSS;
	wt_u32             mDSS;

public:
	MainBlock(ExceptionCompound* ec, wt_u32 css, wt_u32 dss);

	~MainBlock();

	void Accept(AstVisitor* vis);

	MainBlock* Copy();

	Kind GetKind() const
	{
		return MAINBLOCK;
	}

	ExceptionCompound* GetBody()
	{
		return mBody;
	}

	wt_u32 GetCSS() const
	{
		return mCSS;
	}

	wt_u32 GetDSS() const
	{
		return mDSS;
	}
};

} // namespace wtast

#endif // WTPARSER_AST_MAINBLOCK_H
